#include "ee.h"



//////////////////////////////////////////////////////////////////////////////
//
//   Stack definition for MSP430
//
/////////////////////////////////////////////////////////////////////////////

#define STACK_N_SIZE 1024

int EE_x86_stack_1[STACK_N_SIZE];   // Task 0 (Task1)
int EE_x86_stack_2[STACK_N_SIZE];
int EE_x86_stack_3[STACK_N_SIZE];
int EE_x86_stack_4[STACK_N_SIZE];
int EE_x86_stack_5[STACK_N_SIZE];
int EE_x86_stack_6[STACK_N_SIZE];
int EE_x86_stack_7[STACK_N_SIZE];
int EE_x86_stack_8[STACK_N_SIZE];
int EE_x86_stack_9[STACK_N_SIZE];
int EE_x86_stack_10[STACK_N_SIZE];
int EE_x86_stack_11[STACK_N_SIZE];

EE_UREG EE_std_thread_tos[EE_MAX_TASK+1] = {
    0U,      /* dummy*/
    1U,
    2U,
    3U,
    4U,
    5U,
    6U,
    7U,
    8U,
    9U,
    10U,
    11U,
};

struct EE_TOS EE_std_system_tos[EE_MAX_TASK+1] = {
    {0},    // Task   (dummy)
    {(EE_ADDR)(&EE_x86_stack_1[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_2[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_3[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_4[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_5[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_6[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_7[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_8[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_9[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_10[STACK_N_SIZE-4])},
    {(EE_ADDR)(&EE_x86_stack_11[STACK_N_SIZE-4])},
};

EE_UREG EE_x86_active_tos = 0; /* dummy */


/***************************************************************************
 *
 * Kernel ( CPU 0 )
 *
 **************************************************************************/
/* Definition of task's body */
DeclareTask(SignalGatherFinishedTask);
DeclareTask(SignalProcessingActuateTask);
DeclareTask(SignalProcessingAttitudeTask);
DeclareTask(SignalGatherInitiateTask);
DeclareTask(SignalGatherTimeoutTask);
DeclareTask(MavlinkSendTask);
DeclareTask(FlightControlTask);
DeclareTask(FlightControlActuateTask);
DeclareTask(FlightControlAttitudeTask);
DeclareTask(CopterControlTask);
DeclareTask(CopterControlWatchdogTask);

EE_UINT32 EE_terminate_data[EE_MAX_TASK];

const EE_FADDR EE_hal_thread_body[EE_MAX_TASK] = {
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
    (EE_FADDR)EE_oo_thread_stub,
};


const EE_FADDR EE_terminate_real_th_body[EE_MAX_TASK] = {
    (EE_FADDR)FuncSignalGatherFinishedTask,
    (EE_FADDR)FuncSignalProcessingActuateTask,
    (EE_FADDR)FuncSignalProcessingAttitudeTask,
    (EE_FADDR)FuncSignalGatherInitiateTask,
    (EE_FADDR)FuncSignalGatherTimeoutTask,
    (EE_FADDR)FuncMavlinkSendTask,
    (EE_FADDR)FuncFlightControlTask,
    (EE_FADDR)FuncFlightControlActuateTask,
    (EE_FADDR)FuncFlightControlAttitudeTask,
    (EE_FADDR)FuncCopterControlTask,
    (EE_FADDR)FuncCopterControlWatchdogTask,
};

/* ready priority */
const EE_TYPEPRIO EE_th_ready_prio[EE_MAX_TASK] = {
    1 << 11U, // SignalGatherFinishedTask
    1 << 8U,  // SignalProcessingActuateTask
    1 << 7U, // SignalProcessingAttitudeTask
    1 << 10U, // SignalGatherInitiateTask
    1 << 9U, // SignalGatherTimeoutTask
    1 << 3U, // MavlinkSendTask
    1 << 4U, // FlightControlTask
    1 << 6U, // FlightControlActuateTask
    1 << 5U, // FlightControlAttitudeTask
    1 << 2U, // CopterControlTask
    1 << 1U, // CopterControlWatchdogTask
};

/* dispatch priority */
const EE_TYPEPRIO EE_th_dispatch_prio[EE_MAX_TASK] = {
    1 << 11U, // SignalGatherFinishedTask
    1 << 8U,  // SignalProcessingActuateTask
    1 << 7U, // SignalProcessingAttitudeTask
    1 << 10U, // SignalGatherInitiateTask
    1 << 9U, // SignalGatherTimeoutTask
    1 << 3U, // MavlinkSendTask
    1 << 11U, // FlightControlTask
    1 << 6U, // FlightControlActuateTask
    1 << 5U, // FlightControlAttitudeTask
    1 << 2U, // CopterControlTask
    1 << 11U, // CopterControlWatchdogTask

};

/* thread status */
#if defined(__MULTI__) || defined(__WITH_STATUS__)
EE_TYPESTATUS EE_th_status[EE_MAX_TASK] = {
    SUSPENDED,
    SUSPENDED,
    SUSPENDED,
    SUSPENDED,
    SUSPENDED,
    SUSPENDED,
    SUSPENDED,
    SUSPENDED,
    SUSPENDED,
    SUSPENDED,
    SUSPENDED,
};
#endif

/* next thread */
EE_TID EE_th_next[EE_MAX_TASK] = {
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
};

EE_TYPEPRIO EE_th_nact[EE_MAX_TASK];
/* The first stacked task */
EE_TID EE_stkfirst = EE_NIL;

/* The first task into the ready queue */
EE_TID EE_rq_first  = EE_NIL;

// remaining nact: init= maximum pending activations of a Task
// MUST BE 1 for BCC1 and ECC1
EE_TYPENACT   EE_th_rnact[EE_MAX_TASK] =
    { 1, 1, 1, 1, 1,
      1, 1, 1, 1, 1,
      1, };


/* system ceiling */
EE_TYPEPRIO EE_sys_ceiling= 0x0000U;


#ifndef __OO_NO_CHAINTASK__
// The next task to be activated after a ChainTask. initvalue=all EE_NIL
EE_TID EE_th_terminate_nextask[EE_MAX_TASK] = {
EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    EE_NIL,
    };
#endif

//////////////////////////////////////////////////////////////////////////////
//
//   AppMode
//
/////////////////////////////////////////////////////////////////////////////
EE_TYPEAPPMODE EE_ApplicationMode;



//////////////////////////////////////////////////////////////////////////////
//
//   Mutex
//
/////////////////////////////////////////////////////////////////////////////
/*
 * This is the last mutex that the task has locked. This array
 *    contains one entry for each task. Initvalue= all -1. at runtime,
 *    it points to the first item in the EE_resource_stack data structure.
 */
EE_UREG EE_th_resource_last[EE_MAX_TASK] =
    { (EE_UREG) -1,
      (EE_UREG) -1,
      (EE_UREG) -1,
      (EE_UREG) -1,
      (EE_UREG) -1,
      (EE_UREG) -1,
      (EE_UREG) -1,
      (EE_UREG) -1,
      (EE_UREG) -1,
      (EE_UREG) -1,
      (EE_UREG) -1,
    };

/*
 * This array is used to store a list of resources locked by a
 *    task. there is one entry for each resource, initvalue = -1. the
 *    list of resources locked by a task is ended by -1.
 */
EE_UREG EE_resource_stack[EE_MAX_RESOURCE] =
    { (EE_UREG) -1};

/*
 * Only in extended status or when using ORTI with resources; for
 *    each resource, a flag is allocated to see if the resource is locked or
 *    not.  Note that this information cannot be easily knew from the previous
 *    two data structures. initvalue=0
 */
EE_TYPEBOOL EE_resource_locked[EE_MAX_RESOURCE] =
    { 0U};

const EE_TYPEPRIO EE_resource_ceiling[EE_MAX_RESOURCE]= {
    1 << 11U            /* resource Resource */
};

EE_TYPEPRIO EE_resource_oldceiling[EE_MAX_RESOURCE];
/***************************************************************************
 *
 * Counters
 *
 **************************************************************************/
const EE_oo_counter_ROM_type EE_counter_ROM[] = {
    {50000U, 1U, 2U}         /* Counter1 */
};

EE_oo_counter_RAM_type       EE_counter_RAM[EE_MAX_COUNTER] = {
    {0U, -1}
};

const EE_oo_counter_object_ROM_type EE_oo_counter_object_ROM[] = {
    {C1, 0, EE_ALARM},
    {C1, 1, EE_ALARM},
    {C1, 2, EE_ALARM},
};

EE_oo_counter_object_RAM_type EE_oo_counter_object_RAM[EE_MAX_ALARM];

/***************************************************************************
 *
 * Alarms
 *
 **************************************************************************/

const EE_oo_action_ROM_type   EE_oo_action_ROM[] = {
    {EE_ACTION_TASK   , SignalGatherInitiateTask, (EE_VOID_CALLBACK)NULL, -1 },
    {EE_ACTION_TASK    , FlightControlTask, (EE_VOID_CALLBACK)NULL, -1 },
    {EE_ACTION_TASK    , CopterControlWatchdogTask, (EE_VOID_CALLBACK)NULL, -1 }
};

const EE_oo_alarm_ROM_type   EE_alarm_ROM[] = {
    {0},
    {1},
    {2},
};

/* /\*************************************************************************** */
/*  * */
/*  * Auto Start (TASK) */
/*  * */
/*  **************************************************************************\/ */
/* static const EE_TID EE_oo_autostart_task_mode_OSDEFAULTAPPMODE[1] = */
/*     { Task1 }; */

/* const struct EE_oo_autostart_task_type EE_oo_autostart_task_data[EE_MAX_APPMODE] = { */
/*     { 1U, EE_oo_autostart_task_mode_OSDEFAULTAPPMODE} */
/* }; */


/***************************************************************************
 *
 * Auto Start (ALARM)
 *
 **************************************************************************/
static const EE_TYPEALARM EE_oo_autostart_alarm_mode_OSDEFAULTAPPMODE[2] =
    { SignalGatherAlarm, FlightControlAlarm};

const struct EE_oo_autostart_alarm_type EE_oo_autostart_alarm_data[EE_MAX_APPMODE] = {
    { 2U, EE_oo_autostart_alarm_mode_OSDEFAULTAPPMODE}
};


/***************************************************************************
 *
 * Init alarms parameters (ALARM)
 *
 **************************************************************************/

const EE_TYPETICK EE_oo_autostart_alarm_increment[EE_MAX_ALARM] =
    {10U, 13U, 0U };

const EE_TYPETICK EE_oo_autostart_alarm_cycle[EE_MAX_ALARM] =
    {30U, 90U, 0U };
